/////////////////////////////////////////////////////////////////////////////////////////////////
//      /////              /////                                      ///         ////////     //
//      /////              /////                                      ///       /////          //
//       /////            /////                                       ///      ////            //
//       /////            /////                                       ///     ////             //
//        /////          /////                                        ///     ////             //
//        /////          /////                                        ///     ////             //
//         /////        /////                                      /////////  ////             //
//         /////        /////                                      /////////  ////             //
//          /////      /////    //////     ///////    ///             ///     ////             //
//          /////      /////   ///        ///   ///   /// //////      ///     ////             //
//           /////    /////   ///        //////////   //////  ////    ///     ////             //
//           /////    /////   ///        ///          ////     ///    ///     ////      /////  //
//            /////  /////    ///        ///          ///      ///    ///     ////       ////  //
//            /////  /////    ///        ///          ///      ///    ///     /////       ///  //
//             //////////      ///        ///         ///      ///    ///     ///////     ///  //
//             //////////       ///////    ////////   ///      ///    ///      //////////////  //
/////////////////////////////////////////////////////////////////////////////////////////////////

/*
If you use this demo please give me credit (VcentG)
*/
world
	hub = "VcentG.TempFTP"
	name = "VcentG's Temp. FTP"
var
	host = ""
	sizelimit = 10000//auto sets limit to a little under 10 MB
	list
		files = new//list of files

mob
	Login()
		if(host == "")
			host = "[usr.key]"
			world.status = "[host]'s Server! Max Upload Size: [sizelimit] bytes!"
			GO
			var/maxsize = input("What should the file size limit(in bytes(1024 bytes = 1mb)) be for your server?","Size Limit") as num
			if(maxsize <= 0)//check if its atleast 1
				usr << "If its under or equal to 0 then no files can be uploaded!"//let them know it won't go down like that
				goto GO//make them put in a different number
			sizelimit = maxsize//sets the world's max size
			world.status = "[host]'s Server! Max Upload Size: [sizelimit] bytes!"
	Stat()
		statpanel("Files")//a tab for all files so you know what you want to download
		stat("Files:","")
		for(var/A in files)
			stat("[A]","[length(A)] bytes")//shows each file and its size
	verb
		Upload(var/A as file)
			if(!A) return//if no file then stop
			if(!length(A)) return//no 0 byte things here
			if(length(A) > sizelimit)
				usr << "The file is too big for the max upload size!"
				return
			for(var/X in files)
				if(!X) goto SKIP//if there're no files why waste time checking
				if("[X]" == "[A]")//if a file has the same name
					usr << "There is a file already named that!"//just let them know why
					return//stops it since its already made
			SKIP
			files += A//adds the file to the list
		Download()
			var/list/filed = new
			for(var/A in files)
				filed += A//adds all files uploaded to the list
			filed.Add("Cancel")//adds cancel just in case you dont want to download anymore
			var/download = input("What would you like to download?","Download") in filed//asks
			switch(download)
				if("Cancel")
					return//if you dont want to download a file then you can stop
				else
					usr <<  ftp(download)//lets them save the file to their computer